SystemOrganization addCategory: #'Khami-Web'!

WAFileLibrary subclass: #KmResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmResources methodsFor: 'css' stamp: 'StuartHerring 1/15/2011 09:20'!
styleCss
	^'html {
background: lightblue;
}

table.gameBoard {
border-collapse: collapse;
}

table.gameBoard td {
width: 6em;
height: 6em;
font-size: 1em;
}

table.KmTile {
display: inline-block;
	border-width: 0px;
border-collapse: collapse;
padding: 0;
}

table.KmTile td {
width: 1em;
height: 1em;
background-color:lightgrey;
}

.KmTile td.KmFarmRegion {
	background: green;
}
.KmTile td.KmVillageRegion {
	background: brown;
}
.KmTile td.KmRoadPath {
	background: white;
}

'! !

WASession subclass: #KmSession
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:28'!
game
	^game! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initialize
	super initialize.
	self initializeGame.! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initializeGame
	game := KmGame testGame.! !

WAComponent subclass: #KmGameBoardComponent
	instanceVariableNames: 'gameBoard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameBoardComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:28'!
for: aGame
	^self basicNew
		initializeWithGame: aGame;
		yourself! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:28'!
initializeWithGame: aGame
	self initialize.
	gameBoard := aGame board! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/15/2011 09:08'!
renderContentOn: html.
	html table border: 1; class: 'gameBoard';with: [
		(1 to: gameBoard rows) do: [ :r |
			html tableRow: [
				(1 to: gameBoard columns) do: [ :c |
					html tableData: [
						| tile |
						tile := gameBoard at: r at: c.
						tile ifNotNil: [
							html render: (KmTileComponent for: tile)
						]	
					]
				]	
			]	
		]
	]! !

WAComponent subclass: #KmHome
	instanceVariableNames: 'gameBoard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmHome class methodsFor: 'testing' stamp: 'StuartHerring 1/7/2011 14:42'!
canBeRoot
	^true! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 1/12/2011 12:08'!
children
	^Array with: gameBoard! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 1/13/2011 19:34'!
initialize
	super initialize.
	gameBoard := KmGameBoardComponent for: self session game! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:29'!
renderContentOn: html
	self renderMenuOn: html.
	self renderGameBoardOn: html.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/12/2011 12:08'!
renderGameBoardOn: html
	html render: gameBoard! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:37'!
renderMenuItem: text do: aBlock on: html
	html listItem: [html anchor callback: aBlock; with: text ]! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:42'!
renderMenuOn: html
	html unorderedList 
		class: #menu;
		with: [
			self renderMenuItem: 'Show Remaining Tiles' do: [ self showRemaining ] on: html.
		]! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/9/2011 18:32'!
showRemaining
	self call: KmTileList new.! !

!KmHome methodsFor: 'updating' stamp: 'StuartHerring 1/9/2011 08:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WAComponent subclass: #KmTileComponent
	instanceVariableNames: 'tile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileComponent class methodsFor: 'instance creation' stamp: 'StuartHerring 1/13/2011 19:40'!
for: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileComponent methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2011 17:10'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:21'!
renderBlankOn: html
	html tableData
		with: [html space]! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 00:17'!
renderCentrePath: aPath on: html
	html tableData 
		class: aPath class name asSymbol;
		with: [html space]! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:22'!
renderContentOn: html
	html table class: (KmTile class name); with: [
		html tableRow: [
			self renderCornerOn: html.
			self renderHorizontalRegion: (tile regionAt: #topLeft) on: html.
			self renderVerticalPath: (tile pathAt: #top) on: html.
			self renderHorizontalRegion: (tile regionAt: #topRight) on: html.
			self renderCornerOn: html
		].
		html tableRow: [ 
			self renderVerticalRegion: (tile regionAt: #leftTop) on: html.
			self renderBlankOn: html. 
			self renderBlankOn: html.
			self renderVerticalRegion: (tile regionAt: #rightTop) on: html.
		].
		html tableRow: [
			self renderHorizontalPath: (tile pathAt: #left) on: html.
			self renderCentrePath: (tile pathAt: #centre) on: html.
			self renderHorizontalPath: (tile pathAt: #right) on: html
			].
		html tableRow: [ 
			self renderVerticalRegion: (tile regionAt: #leftBottom) on: html.
			self renderBlankOn: html. 
			self renderVerticalPath: (tile pathAt: #bottom) on: html.
			self renderBlankOn: html.
			self renderVerticalRegion: (tile regionAt: #rightBottom) on: html.
		].
		html tableRow: [
			self renderCornerOn: html.
			self renderHorizontalRegion: (tile regionAt: #bottomLeft) on: html.
			self renderHorizontalRegion: (tile regionAt: #bottomRight) on: html.
			self renderCornerOn: html
		]
	]	
! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 08:10'!
renderCornerOn: html
	html tableData: [html space]! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:21'!
renderHorizontalPath: aPath on: html
	html tableData 
		colSpan: 2;
		class: aPath class name asSymbol;
		with: [html space]! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:21'!
renderHorizontalRegion: aRegion on: html
	html tableData 
		class: aRegion class name asSymbol;
		with: [html space]! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:21'!
renderVerticalPath: aPath on: html
	html tableData 
		rowSpan: 2;
		class: aPath class name asSymbol;
		with: [html space]! !

!KmTileComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:21'!
renderVerticalRegion: aRegion on: html
	html tableData 
		class: aRegion class name asSymbol;
		with: [html space]! !

WAComponent subclass: #KmTileList
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileList class methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 18:25'!
canBeRoot
	^true! !

!KmTileList methodsFor: 'hooks' stamp: 'StuartHerring 1/10/2011 09:42'!
children
	^Array withAll: children! !

!KmTileList methodsFor: 'initialization' stamp: 'StuartHerring 1/13/2011 19:40'!
initialize
	super initialize.
	children := OrderedCollection new.
	children addAll: ((self session game remainingTiles) collect: [ :tile | KmTileComponent for: tile])! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:41'!
renderContentOn: html
	html heading level: 2; with: 'Tiles Remaining'.	
	children do: [ :c |
		html render: c
	].
	html break.
	html anchor callback: [ self answer ]; with: 'Close'
! !

!KmTileList methodsFor: 'updating' stamp: 'StuartHerring 1/9/2011 18:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !
